#include "ti82.h"
#include "keys.inc"

   .org START_ADDR
   .db  "Test for Convergence",0
  
start:
  call sub0
  ld   hl,text1
  call sub1
  ld   hl,text2
  call sub2
  ld   hl,text7
  call sub3
  ld   hl,text3
  call sub4
  ld   hl,text4
  call sub6
  ld   hl,text5
  call sub7
  ld   hl,text6
  ROM_CALL(D_ZT_STR)

geta:
  call GET_KEY
  cp   G_ENTER
  jp   z,label_y
  jr   geta
  
label_y:
  call sub0
  ld   hl,text48
  call sub1
  ld   hl,text49
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
   
get1:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_a
  cp   G_WINDOW
  jp   z,label_ya
  cp   G_CLEAR
  jp   z,label_z
  jr   get1
  
label_ya:
  call sub0
  ld   hl,text21
  ROM_CALL(D_ZT_STR)
  
gety:
  call sub7
  ld   hl,text50
  ROM_CALL(D_ZT_STR)
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_y
  cp   G_CLEAR
  jp   z,label_z
  jr   gety
  
label_a:
  call sub0
  ld   hl,text10
  call sub1
  ld   hl,text11
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
    
get2:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_aa
  cp   G_WINDOW
  jp   z,label_b
  cp   G_CLEAR
  jp   z,label_z
  jr   get2

label_aa:
  call sub0
  ld   hl,text12
  call sub1
  ld   hl,text13
  call sub2
  ld   hl,text14
  call sub3
  ld   hl,text15
  jr   gety

label_b:
  call sub0
  ld   hl,text16
  call sub1
  ld   hl,text17
  call sub2
  ld   hl,text18
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
  
get3:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_ba
  cp   G_WINDOW
  jp   z,label_c
  cp   G_CLEAR
  jp   z,label_z
  jr   get3
  
label_ba:
  call sub0
  ld   hl,text19
  call sub1
  ld   hl,text20
  call sub2
  ld   hl,text21
  call sub3
  ld   hl,text22
  jp   gety

label_c:
  call sub0
  ld   hl,text23
  call sub1
  ld   hl,text24
  call sub2
  ld   hl,text25
  call sub3
  ld   hl,text26
  call sub4
  ld   hl,text27
  call sub5
  ld   hl,text28
  call sub6
  ld   hl,text29
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
  
get4:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_ca
  cp   G_WINDOW
  jp   z,label_d
  cp   G_CLEAR
  jp   z,label_z
  jr   get4

label_ca:
  call sub0
  ld   hl,text31
  call sub1
  ld   hl,text32
  jp   gety

label_d:
  call sub0
  ld   hl,text33
  call sub1
  ld   hl,text34
  call sub2
  ld   hl,text35
  call sub3
  ld   hl,text36
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
  
get5:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_e
  cp   G_WINDOW
  jp   z,label_da
  cp   G_CLEAR
  jp   z,label_z
  jr   get5
  
label_da:
  call sub0
  ld   hl,text44
  call sub1
  ld   hl,text45
  call sub2
  ld   hl,text46
  call sub3
  ld   hl,text47
  jp   gety

label_e:
  call sub0
  ld   hl,text37
  call sub1
  ld   hl,text38
  call sub2
  ld   hl,text39
  call sub7
  ld   hl,text8
  ROM_CALL(D_ZT_STR)
  
get6:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_f
  cp   G_WINDOW
  jp   z,label_da
  cp   G_CLEAR
  jp   z,label_z
  jr   get6  

label_f:
  call sub0
  ld   hl,text40
  call sub1
  ld   hl,text41
  call sub2
  ld   hl,text42
  call sub3
  ld   hl,text43
  call sub7
  ld   hl,text8
  jp   gety

sub0:
  ROM_CALL(CLEARLCD)
  ld   de,$0000
  ld   (CURSOR_ROW),de
  ret

sub1:
  ROM_CALL(D_ZT_STR)
  ld   de,$0001
  ld   (CURSOR_ROW),de
  ret

sub2:
  ROM_CALL(D_ZT_STR)
  ld   de,$0002
  ld   (CURSOR_ROW),de
  ret

sub3:
  ROM_CALL(D_ZT_STR)
  ld   de,$0003
  ld   (CURSOR_ROW),de
  ret

sub4:
  ROM_CALL(D_ZT_STR)
  ld   de,$0004
  ld   (CURSOR_ROW),de
  ret

sub5:
  ROM_CALL(D_ZT_STR)
  ld   de,$0005
  ld   (CURSOR_ROW),de
  ret

sub6:
  ROM_CALL(D_ZT_STR)
  ld   de,$0006
  ld   (CURSOR_ROW),de
  ret

sub7:
  ROM_CALL(D_ZT_STR)
  ld   de,$0007
  ld   (CURSOR_ROW),de
  ret

label_z:
  ret

text1:
.db "PROCEDURE FOR",0
text2:
.db "DETERMINING",0
text3:
.db "V1.0",0
text4:
.db "(C) 2002",0
text5:
.db "WILSON NG",0
text6:
.db "WAESH@YAHOO",0
text7:
.db "CONVERGENCE",0

text8:
.db "YES NO",0
text9:
.db "SERIES DEVIRGES",0
text10:
.db "GEOMETRIC",0
text11:
.db "IS An=a+ar+ar+.",0
text12:
.db "CONVERGES a/",0
text13:
.db "(1-r) IF abs r<1",0
text14:
.db "DIVERGES IF",0
text15:
.db "abs r1",0

text16:
.db "P-SERIES",0
text17:
.db "DOES SERIES HAVE",0
text18:
.db "FORM 1/n^P,n=1-INF",0
text19:
.db "SERIES CONVERGES",0
text20:
.db " IF P>1",0
text21:
.db "SERIES DIVERGES",0
text22:
.db " IF P1",0

text23:
.db "POSITIVE TERMS",0
text24:
.db "and/Or abs CON-",0
text25:
.db "VERGENCE DOES",0
text26:
.db "?absAn CONVERGE?",0
text27:
.db "APPLY COMPARISON",0
text28:
.db ",INTEGRAL,RATIO,",0
text29:
.db "ETC TO ?abs An",0

text31:
.db "ORIGINAL SERIES",0
text32:
.db "CONVERGE",0
text33:
.db "ALTERN... SERIES",0
text34:
.db "IS ?An=U1-U2+U3-",0
text35:
.db "..?(AN ALTERN..",0
text36:
.db " SERIES)",0

text37:
.db "IS THERE AN IN-",0
text38:
.db "TEGER N SUCH ",0
text39:
.db "THAT UNUN+1..?",0

text40:
.db "SERIES CONVERGE",0
text41:
.db " IF Un-)0",0
text42:
.db "SERIES DIVERGE",0
text43:
.db "IF Un0",0

text44:
.db "TRY PARTIAL SUMS",0
text45:
.db "CONSULT ADVANCED",0
text46:
.db "BOOKS,Or EXPLORE",0
text47:
.db "WITH A CAS",0

text48:
.db "NTH-TERM",0
text49:
.db "IS LIM AN=0?",0
text50:
.db "AGAIN",0

.end

